﻿using EPiServer.Common;
using EPiServer.Common.Data;
using EPiServer.Common.Security;

namespace ExampleProjects.Movie
{
    public class Movie : FrameworkEntityBase 
    {
        private int _authorUserID;

        public Movie(string title, IUser author)
            : base(-1)
        {
            Title = title;
            _authorUserID = author.ID;
        }

        internal Movie(int id, string title, int? runtime, int authorID)
            : base(id)
        {
            Title = title;
            RuntimeMinutes = runtime;
            _authorUserID = authorID;
        }

        public string Title { get; set; }

        public int? RuntimeMinutes { get; set; }

        public IUser Author
        {
            get
            {
                return EntityProviderHandler.GetEntityProvider(
                    typeof (IUser)).GetEntityInstance(typeof (IUser),
                    _authorUserID) as IUser;
            }
            
            set
            {
                _authorUserID = value.ID;    
            }
        }

        internal static string[] ConstructCacheKey(int id)
        {
            return new [] { MovieModule.Instance.UniqueName, 
                "Movie", id.ToString() };
        }

        public override string[] CacheKey
        {
            get { return ConstructCacheKey(ID); }
        }
    }
}
